import {createStore, applyMiddleware, combineReducers} from 'redux';
import thunk from 'redux-thunk';


const reducers = {
    promise(state={}, action){
        if (['LOGOUT', 'LOGIN'].includes(action.type)) return {}
        if (action.type === 'PROMISE'){
            const { name="default", status, payload, error} = action
            if (status){
                return {
                    ...state, [name]: {status, payload: (status === 'PENDING' && state[name] && state[name].payload) || payload, error}
                }
            }
        }
        return state;
    },
    //auth(){ //....

    //}
}

let store = createStore(combineReducers(reducers), applyMiddleware(thunk))

const delay = ms => new Promise(ok => setTimeout(() => ok(ms), ms))


export default store

